@echo off

setlocal

set __lintexe=%LINTNT_EXE_PATH%\lint-nt.exe
set __aloaexe=%ALOA_EXE_PATH%\aloa.exe
set __project_file=%1
if not "%2" == "-default" set __config=-dConfiguration=%2
set __file=%3

if "%__project_file%" == "" goto SHOW_HELP
if "%2" == "" goto SHOW_HELP

for %%i in (.) do set __currdir=%%~fi
set __project_lnt_file=%__currdir%\vcproj.lnt
set __aloa_lnt_file=%__currdir%\..\aloa.lnt

for %%i in (%__project_file%) do set __project_dir=%%~dpi

%__lintexe% -v > nul 2>&1
if not %ERRORLEVEL% == 0 goto LINT_MISSING

rem *** Extract project specific settings
echo Project is %__project_file%
%__lintexe% -b %__config% %__project_file% > %__project_dir%\_project.lnt

cd /d %__project_dir%
set __singlecheckout=--u
if "%__file%" == "" set __singlecheckout=
if "%__file%" == "-aloa" goto LINT_ALOA

echo Linting %__file%
%__lintexe% %__singlecheckout% %__project_lnt_file% %__file% %4 %5 %6 %7 %8
goto END

:LINT_ALOA
echo Linting project
%__lintexe% -b %__aloa_lnt_file% > _aloa.xml
echo Executing ALOA
%__aloaexe% _aloa.xml
if %ERRORLEVEL% == 0 goto END
if %ERRORLEVEL% == -1 goto END
goto ALOA_MISSING

:SHOW_HELP

echo.
echo VCPROJLINTER
echo.
echo Usage: 
echo    vcprojlinter [^<vcproj-file^>] [^<config^> ^| -default] [^<file^> ^| -aloa]
echo.
echo Description:
echo    Takes the project settings from ^<vcproj-file^> for a given
echo    ^<configuration^> and lints the given ^<file^>, if provided.
echo    If ^<configuration^> equals -default uses the default
echo    configuration (ie. currently active configuration).
echo    If ^<file^> is ommitted, the whole project is linted.
echo    If ^<file^> equals -aloa, runs ALOA on all project files.
echo.
echo Examples:
echo    vcprojlinter x:\myprj\alpha\alpha.vcproj -default -aloa
echo    vcprojlinter x:\myprj\alpha\alpha.vcproj -default x:\myprj\alpha\src\main.cpp
echo    vcprojlinter x:\myprj\alpha\alpha.vcproj -default x:\myprj\alpha\src\main.cpp
echo    vcprojlinter x:\myprj\alpha\alpha.vcproj "Debug" -aloa
echo    vcprojlinter x:\myprj\alpha\alpha.vcproj "Release" -aloa
echo.
goto END

:LINT_MISSING
echo.
echo Cannot find lint-nt.exe.
echo Please define an environment variable named 'LINTNT_EXE_PATH' that
echo contains the absolute path to PC-Lint's lint-nt.exe
echo.
goto END

:ALOA_MISSING
echo.
echo Cannot find aloa.exe
echo Please define an environment variable named 'ALOA_EXE_PATH' that
echo contains the absolute path to ALOA's executable (aloa.exe)
echo.
goto END

:END
endlocal

